// RecurringEvent.java                                           -*- Java -*-
//    An class for creating events that keep happening
//
// COPYRIGHT (C) 1998 Bradley M. Kuhn, All Rights Reserved.
//
// Written   :   Bradley M. Kuhn         University of Cincinnati
//   By          
//
// Written   :   John Franco
//   For         Special Topics: Java Programming
//               15-625-595-001, Fall 1998
// RCS       :
//
// $Source: /home/server/Project/RCS/RecurringEvent.java $
// $Revision: 0.3 $
// $Date: 1998/11/30 14:12:09 $
//
// $Log: RecurringEvent.java $
// Revision 0.3  1998/11/30 14:12:09  bkuhn
//   -- fixed error message in exception
//
// Revision 0.2  1998/11/30 10:13:54  bkuhn
//   -- made it serializable because of wars
//
// Revision 0.1  1998/11/13 09:13:36  bkuhn
//   # initial version
//
//
import java.io.Serializable;

/*****************************************************************************/
// Note that we Serialize this class....This is  for convience only!
// Make sure you make a new one of these instead when you bring this back in

class RecurringEvent extends Thread implements Serializable
{
      Class recurringClass;
      long  milliseconds;
      Object initializingObject;

      /**********************************************************************/
      /* Note that myClass *must* implement RecurringEvent
       */
      RecurringEvent(Class myClass, Object o, double seconds)
         throws ClassNotFoundException
      {
         milliseconds = (long) (seconds * 1000);

         initializingObject = o;

         recurringClass = myClass;

         Class[] interfaces = myClass.getInterfaces();
         boolean haveRecurredEvent = false;

         for(int ii = 0; ii < interfaces.length; ii++)
            if (interfaces[ii] == Class.forName("RecurredEvent"))
            {
               haveRecurredEvent = true;
               break;
            }

         if (! haveRecurredEvent)
            throw new ClassNotFoundException(
               "does not implement RecurredEvent!");
         
         setPriority(NORM_PRIORITY - 3);
      }
      /**********************************************************************/
      public void run()
      {
         while (true)
         {
            // sleep() for the required amount
            performSleep();

            RecurredEvent r;
            try
            {
               r = (RecurredEvent) recurringClass.newInstance();
            }
            catch (Exception e)
            {
               System.out.println("PLAYER: unable to instantiate, " +
                                  recurringClass.getName() + 
                                  " in RecurringEvent");
               break;
            }

            r.initialize(initializingObject);

            r.setPriority(this.getPriority());
            r.run();

            // wait for this fellow to terminate
            try { r.join(); }
            catch(InterruptedException ie) { }
         }
      }
      /**********************************************************************/
      void performSleep()
      {
         try
         {
            sleep(milliseconds);
         }
         catch (InterruptedException  ie) { }
      }
}

/*
  Local Variables:
  tab-width: 4
  indent-tabs-mode: nil
  eval: (c-set-style "ellemtel")
  End:
*/
